module mcu3 (clk,addr,datain,dataout,wr,rd,autoinc,ready,      // P1V interface
             sram_addr,sram_ce_n,sram_dq,sram_lb_n,sram_oe_n,sram_ub_n,sram_we_n,//m9k interface
				 m9kwr,m9krd,m9krdb,addrb,m9kwrb,dpr_clk,pixval,pixin,pixready,pixaddr);   
input wire clk,wr,rd,autoinc;
input wire m9kwr,m9krd,m9krdb,m9kwrb,dpr_clk;  
output wire ready;
input wire [20:0] addr;
input wire[18:0]  addrb;
input wire[31:0] datain;
output reg [31:0] dataout;
reg [7:0] zerodata;
reg [7:0] m9kq;//
wire [7:0] m9kqb;
input wire [7:0] pixin;
input wire pixready;
input wire [24:0] pixaddr;
output reg[23:0] pixval;
output reg [19:0] sram_addr;
inout wire [15:0] sram_dq;
output wire sram_ce_n,sram_oe_n;
output reg sram_lb_n,sram_ub_n,sram_we_n;
reg m9kwr_e,m9krd_e,m9kw_eb,m9krd_eb;
reg [7:0] m9kdata;
reg oldsram_we_n;
reg [15:0] sramdqout;
reg oldwr,wr2,wr3,wr4,wr5,wr6,wr7,wr8,wr9,wr10,newaddr;
reg oldm9kwr,oldm9krd,m9kwr2,m9krd2;
reg oldm9krdb,m9krdb2,m9krdb3;
reg oldauto;
reg oldrd,rd2,rd3,rd4,rd5,rd6,rd7,rd8;
reg [7:0] m9kdata_a;
assign sram_ce_n=0;
assign sram_oe_n=0;
assign sram_lb_n=0;
assign sram_ub_n=0;
assign zerodata=0;
assign sram_dq = (sram_we_n==0) ? sramdqout : 16'bz;
wire [18:0] address_a_sig;
wire [18:0] address_b_sig;
assign m9kwr_e =pixready; //m9kwr;
assign address_a_sig = pixaddr[18:0];
assign address_b_sig = addrb[18:0];
assign m9kdata_a = pixin[7:0];
assign m9krd_e=m9krd;
assign sramdqout=datain[15:0]; 
assign sram_addr =addr[19:0];
rjom9k	rjom9k_inst (
	.address_a ( address_a_sig ),
	.address_b ( address_b_sig ),
	.clock (dpr_clk ),
	.data_a ( m9kdata_a),
	.data_b ( zerodata[7:0] ),
	.rden_a ( m9krd_e ),
	.rden_b ( m9krdb ),
	.wren_a ( m9kwr_e),
	.wren_b (m9kw_eb ),
	.q_a ( dataout[31:16]),
	.q_b ( m9kqb )
	);
always@(posedge dpr_clk)
  begin  
  //read m9k port b... set up to output data through pixel bus to vga module
   if ( m9krdb==1)
 	begin
		 m9krdb2<=1;  //sequential states 
		end
		else 
		begin
		m9krdb2<=0;
		end
    if ( m9krdb2==1)//wait two clocks to allow correct memory alignment
    begin
		pixval<=m9kqb; //transfer value to bus
	 end
  end
always@(posedge clk)
  begin  
  oldwr<=wr;
//  oldrd<=rd;
  oldm9krd<=m9krd;
  oldm9krdb<=m9krdb;
  oldm9kwr<=m9kwr;
 //read data from sram to dataout->( inb[15:0]
  if (rd==1) begin
    rd2<=1; 
  end
  else 
  begin
    rd2<=0;
  end
  if (rd2==1)  begin dataout[15:0]<=sram_dq; end

//write sram data from p1v: outb to sram datain
  if ((oldwr==0) &&(wr==1)) begin
    wr2<=1; 
	 sram_we_n<=0;
  end
  else 
  begin
    wr2<=0;
  end
 if (wr2==1)
 begin
     sram_we_n<=1;
 end 
 end
endmodule
// This is free software, license: LGPL v.2.0 or newer